//! Like v4.rs, but with IPv6.

use wasi::sockets::network::{IpAddressFamily, IpSocketAddress, Ipv6SocketAddress};
use wasi::sockets::{instance_network, tcp, tcp_create_socket};
use wasi_sockets_tests::*;

fn main() {
    let net = instance_network::instance_network();

    let sock = tcp_create_socket::create_tcp_socket(IpAddressFamily::Ipv6).unwrap();

    let addr = IpSocketAddress::Ipv6(Ipv6SocketAddress {
        port: 0,                           // use any free port
        address: (0, 0, 0, 0, 0, 0, 0, 1), // localhost
        flow_info: 0,
        scope_id: 0,
    });

    let sub = tcp::subscribe(sock);

    tcp::start_bind(sock, net, addr).unwrap();

    wait(sub);
    wasi::poll::poll::drop_pollable(sub);

    tcp::finish_bind(sock).unwrap();

    example_body(net, sock, IpAddressFamily::Ipv6)
}
